AppDomain.FirstChanceException AppDomain.FirstChanceException AppDomain.FirstChanceException AppDomain.FirstChanceException Event

Определение

Происходит при создании исключения в управляемом коде, перед тем как среда выполнения ищет стек вызовов для обработчика исключений в домене приложений.Occurs when an exception is thrown in managed code, before the runtime searches the call stack for an exception handler in the application domain.

public:
 event EventHandler<System::Runtime::ExceptionServices::FirstChanceExceptionEventArgs ^> ^ FirstChanceException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> FirstChanceException;
member this.FirstChanceException : EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> 
Public Custom Event FirstChanceException As EventHandler(Of FirstChanceExceptionEventArgs) 
Атрибуты

Примеры

В следующем примере создается ряд доменов приложений с именем AD0 AD3с Worker использованием объекта в каждом домене приложения.The following example creates a series of application domains named AD0 through AD3, with a Worker object in each application domain. Каждый Worker объект имеет ссылку Worker на объект в следующем Worker домене приложения, за исключением объекта в последнем домене приложения.Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. Событие обрабатывается во всех доменах приложений, за исключением AD1. FirstChanceExceptionThe FirstChanceException event is handled in all application domains except AD1.

Примечание

В дополнение к этому примеру, в котором демонстрируются уведомления о первичных исключениях в нескольких доменах приложений, можно найти простые варианты использования в следующих разделах: Получение уведомлений опервом экземпляре исключения.In addition to this example, which demonstrates first-chance exception notifications in multiple application domains, you can find simple use cases in How to: Receive First-Chance Exception Notifications.

После создания доменов приложений домен приложения по умолчанию вызывает TestException метод для первого домена приложения.When the application domains have been created, the default application domain calls the TestException method for the first application domain. Каждый Worker объект Worker вызывает метод для следующего домена приложения до тех пор, пока не будет создано исключение, которое обрабатывается или необработанным. TestExceptionEach Worker object calls the TestException method for the next application domain, until the last Worker throws an exception that is either handled or unhandled. Таким же, текущий поток проходит через все домены приложений и TestException добавляется в стек в каждом домене приложения.Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

Когда последний Worker объект обрабатывает исключение FirstChanceException , событие возникает только в последнем домене приложения.When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. Другие домены приложений никогда не получают возможность обработки исключения, поэтому событие не возникает.The other application domains never get a chance to handle the exception, so the event is not raised.

Когда последний Worker объект не обрабатывает исключение FirstChanceException , событие возникает в каждом домене приложения с обработчиком событий.When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. После завершения каждого обработчика событий стек продолжит работать до тех пор, пока исключение не будет перехвачено доменом приложения по умолчанию.After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

Примечание

Чтобы увидеть, как растет отображение стека по мере того, как событие порождается ближе к домену приложения e.Exception.Message по e.Exception умолчанию FirstChanceHandler , измените на в обработчиках событий.To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. Обратите внимание TestException , что когда вызывается через границы домена приложения, он появляется дважды: один раз для прокси-сервера и один раз для заглушки.Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

Комментарии

Это событие является только уведомлением.This event is only a notification. Обработка этого события не обрабатывает исключение или влияет на последующую обработку исключений каким бы то ни было образом.Handling this event does not handle the exception or affect subsequent exception handling in any way. После того как событие вызвано и были вызваны обработчики событий, среда CLR начинает поиск обработчика для исключения.After the event has been raised and event handlers have been invoked, the common language runtime (CLR) begins to search for a handler for the exception. FirstChanceExceptionпредоставляет домен приложения с первой возможностью проверить любое управляемое исключение.FirstChanceException provides the application domain with a first chance to examine any managed exception.

Событие может быть обработано для каждого домена приложения.The event can be handled per application domain. Если поток проходит через несколько доменов приложений во время выполнения вызова, событие возникает в каждом домене приложения, который зарегистрировал обработчик событий, прежде чем среда CLR начнет поиск соответствующего обработчика исключений в этом домене приложения.If a thread passes through multiple application domains while executing a call, the event is raised in each application domain that has registered an event handler, before the CLR begins searching for a matching exception handler in that application domain. После обработки события выполняется поиск соответствующего обработчика исключений в этом домене приложения.After the event has been handled, a search is made for a matching exception handler in that application domain. Если ничего не найдено, событие возникает в следующем домене приложения.If none is found, the event is raised in the next application domain.

Все исключения, происходящие в обработчике событий для FirstChanceException события, должны быть обработаны.You must handle all exceptions that occur in the event handler for the FirstChanceException event. FirstChanceException В противном случае вызывается рекурсивно.Otherwise, FirstChanceException is raised recursively. Это может привести к переполнению стека и завершению работы приложения.This could result in a stack overflow and termination of the application. Рекомендуется реализовать обработчики событий для этого события в виде областей ограниченного выполнения (CER), чтобы исключения, связанные с инфраструктурой, такие как нехваткой памяти или переполнение стека, не влияли на виртуальную машину, пока не будет уведомление об исключении. обрабатывается.We recommend that you implement event handlers for this event as constrained execution regions (CERs), to keep infrastructure-related exceptions such as out-of-memory or stack overflow from affecting the virtual machine while the exception notification is being processed.

Это событие не вызывается для исключений, которые указывают на повреждение состояния процесса, например нарушения прав доступа, если только обработчик событий не является критически важным для безопасности HandleProcessCorruptedStateExceptionsAttribute и имеет атрибут.This event is not raised for exceptions that indicate corruption of process state, such as access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

Среда CLR приостанавливает прерывание потока во время обработки этого события уведомления.The common language runtime suspends thread aborts while this notification event is being handled.

Безопасность

SecurityCriticalAttribute
требуется полное доверие для немедленного вызывающего объекта.Requires full trust for the immediate caller. Этот член не может использоваться частично доверенным или прозрачным кодом.This member cannot be used by partially trusted or transparent code.

Применяется к

Дополнительно